/* communication modul
 * used for communication between environment {drawmaze}
 * and any robot implementation
 */

#include <stdio.h>
#include "comm.h"

int home()
{
FILE *f;
int step;

  if ((f = fopen("home.bot", "rb")) != NULL) {
    fread(&step, sizeof(step), 1, f);
    close(f);
    unlink("home.bot");
    return step;
  }
  return 0;
}

void hit_home(int step)
{
FILE *f;

  f = fopen ("home.bot","wb");
  fwrite(&step, sizeof(step), 1, f);
  fclose(f);
}

int bump()
{
FILE *f;

  if ((f = fopen("bump.bot", "rb")) != NULL) {
    close(f);
    unlink("bump.bot");
    return 1;
  }
  return 0;
}

void hit_bump(Tpos pos)
{
FILE *f;

  f = fopen ("bump.bot","wb");
  fwrite(&pos, sizeof(pos), 1, f);
  fclose(f);
}

Tsens getSens()
{
FILE *f;
Tsens sens;

  if ((f = fopen("sens.bot", "rb")) != NULL) {
    fread(&sens, sizeof(sens), 1, f);
    close(f);
    return sens;
  }
}

void setSens(Tsens sens)
{
FILE *f;

  f = fopen ("sens.bot","wb");
  fwrite(&sens, sizeof(sens), 1, f);
  fclose(f);
}

Tpos getPos()
{
FILE *f;
Tpos pos;

  if ((f = fopen("pos.bot", "rb")) != NULL) {
    if(fread(&pos,sizeof(pos),1,f) != 1) {
      printf("Error reading pos.bot file.\n");
      ErrNo = 1;
    }
    close(f);
    ErrNo = 0;
    return pos;
  }
  else {
     printf("Couldn't open pos.bot file.\n");
     ErrNo = 1;
  }
}

void setPos(Tpos pos)
{
FILE *f;

  f = fopen ("pos.bot","wb");
  fwrite(&pos, sizeof(pos), 1, f);
  fclose(f);
}
