typedef struct{
  int x,y,       /* suradnice */
      dir;       /* smer otocenia  (0-3=p,d,l,h) */
  } Tpos;

typedef struct{
	int lf,rt,fw,bk;  /* co vidia senzory: lavy,pravy,predny,zadny */
} Tsens;

typedef struct{
  short int DNA[16];
  int value;
  int generation;
} Tdna;

typedef struct{
  Tsens sens;
  Tpos pos;
  int ID;
  int inf;
} Tant;
  
#define TRUE 	 1
#define FALSE	 0

/* konstanty na vyziadanie komunikacie so serverom */
#define GETSENS  	 1
#define GETPOS   	 2
#define WALL     	 3
#define HOME     	 4
#define SETPOS   	 5
#define CLEARFIELDS	 6
#define GETNFIELDS	 7
#define ACOSIM		 8
#define TIMESTEP         9
#define CONTENT		10
#define SETCONT		11
#define START		12
#define BEST		13


#define SOCK_PATH "bot_socket"

int ErrNo;		  /* chybove hlasenia funkcii */

extern int wait_client();
extern int call_server();
extern int home(int s, Tant *ant);
extern void hit_home(Tdna hp);
extern int bump(int s,Tant *ant);
extern void hit_bump(Tpos pos);
extern void setSens(Tsens sens);
extern Tsens getSens(int s, Tant *ant);
extern void setPos(int s, Tant *ant);
extern Tpos getPos(int s, Tant *ant);
extern void clearfields(int s);
extern int getNfields(int s);
extern void setACO(int s);
extern void makeTimestep(int s);
extern void content(int s, Tant *ant);
extern void setContent(int s, Tant *ant);
extern int atStart(int s, Tant *ant);
extern int AmIBest(int s, Tant *ant);

